#include <stdarg.h>
#define _LOOSE_KERNEL_NAMES 
#include <linux/types.h>
#include <linux/unistd.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/ctype.h>
#include <linux/signal.h>
#include <linux/resource.h>
#include <linux/times.h>
#include <linux/utime.h>
#include <linux/dirent.h>
#include <linux/reboot.h>
#include <asm/statfs.h>
#define __KERNEL__
#include <linux/stat.h>
#undef __KERNEL__

/* Here is stuff we must add */

#define INT_MAX         ((int)(~0U>>1))
#define INT_MIN		(-INT_MAX - 1)
#define UINT_MAX        (~0U)
#define LONG_MAX        ((long)(~0UL>>1))
#define LONG_MIN	(-LONG_MAX - 1L)
#define ULONG_MAX       (~0UL)
#define MININT          INT_MIN
#define MINLONG         LONG_MIN
#define MAXINT          INT_MAX
#define MAXLONG         LONG_MAX


typedef __sighandler_t(*sighandler_t) (int);

struct mmap_arg_struct {
	unsigned long addr;
	unsigned long len;
	unsigned long prot;
	unsigned long flags;
	unsigned long fd;
	unsigned long offset;
};


int atoi(const char *nptr);
long atol(const char *nptr);
double atof(const char *nptr);
unsigned long strtoul(const char *nptr, char **endptr, int base);
long strtol(const char *nptr, char **endptr, int base);
int sprintf(char *str, const char *format, ...);
/* This one has only 1024 char buffer - don't overflow it */
void printf(const char *format, ...);


void exit(int status);
pid_t fork();
ssize_t read(int fd, void *buf, size_t count);
ssize_t write(int fd, const void *buf, size_t count);
int open(const char *pathname, int flags, mode_t mode);
int close(int fd);
pid_t waitpid(pid_t pid, int *status, int options);
int creat(const char *pathname, mode_t mode);
int link(const char *oldpath, const char *newpath);
int unlink(const char *pathname);
int execve(const char *filename, char **const argv, char **const envp);
int chdir(const char *path);
time_t time(time_t * t);
int mknod(const char *pathname, mode_t mode, dev_t dev);
int chmod(const char *path, mode_t mode);
int lchown(const char *path, uid_t owner, gid_t group);
off_t lseek(int fildes, off_t offset, int whence);
pid_t getpid();
int mount(const char *specialfile, const char *dir,
	  const char *filesystemtype, unsigned long rwflag,
	  const void *data);
int umount(const char *dir);
int setuid(uid_t uid);
uid_t getuid();
int stime(time_t * t);
int ptrace(int request, int pid, int addr, int data);
unsigned int alarm(unsigned int seconds);
int pause();
int utime(const char *filename, struct utimbuf *buf);
int access(const char *pathname, int mode);
int nice(int inc);
int sync();
int kill(pid_t pid, int sig);
int rename(const char *oldpath, const char *newpath);
int mkdir(const char *pathname, mode_t mode);
int rmdir(const char *pathname);
int dup(int oldfd);
int pipe();
clock_t times(struct tms *buf);
int brk(void *end_data_segment);
int setgid(gid_t gid);
gid_t getgid();
sighandler_t signal(int signum, sighandler_t handler);
uid_t geteuid();
gid_t getegid();
int acct(const char *filename);
int umount2(char *name, int flags);
int ioctl(unsigned int fd, unsigned int cmd, unsigned long arg);
int fcntl(int fd, int cmd, long arg);
int setpgid(pid_t pid, pid_t pgid);
mode_t umask(mode_t mask);
int chroot(const char *path);
int ustat(dev_t dev, struct ustat *ubuf);
int dup2(int oldfd, int newfd);
pid_t getppid();
pid_t getpgrp();
pid_t setsid();
int sigaction(int signum, const struct sigaction *act,
	      struct sigaction *oldact);
int sgetmask(void);
int ssetmask(int newmask);
int setreuid(uid_t ruid, uid_t euid);
int setregid(gid_t rgid, gid_t egid);
int sigsuspend(const sigset_t * mask);
int sigpending(sigset_t * set);
int sethostname(const char *name, size_t len);
int setrlimit(int resource, const struct rlimit *rlim);
int getrlimit(int resource, struct rlimit *rlim);
int getrusage(int who, struct rusage *usage);
int gettimeofday(struct timeval *tv, struct timezone *tz);
int settimeofday(const struct timeval *tv, const struct timezone *tz);
int getgroups(int size);
int setgroups(size_t size, const gid_t * list);
int select(int n, fd_set * readfds, fd_set * writefds, fd_set * exceptfds,
	   struct timeval *timeout);
int symlink(const char *oldpath, const char *newpath);
int readlink(const char *path, char *buf, size_t bufsiz);
int uselib(const char *library);
int swapon(const char *path, int swapflags);
int reboot(int magic, int magic2, int flag, void *arg);
int readdir(unsigned int fd, struct dirent *dirp, unsigned int count);
int mmap(struct mmap_arg_struct *arg);
int munmap(void *start, size_t length);
int truncate(const char *path, size_t length);
int ftruncate(int fd, size_t length);
int fchmod(int fildes, mode_t mode);
int fchown(int fd, uid_t owner, gid_t group);
int getpriority(int which, int who);
int setpriority(int which, int who, int prio);
int statfs(const char *path, struct statfs *buf);
int fstatfs(unsigned int fd, struct statfs *buf);
int ioperm(unsigned long from, unsigned long num, int turn_on);
int getitimer(int which, struct itimerval *value);
int setitimer(int which, const struct itimerval *value,
	      struct itimerval *ovalue);
int socketcall(int call, unsigned long *args);
int syslog(int type, char *bufp, int len);
int stat(const char *file_name, struct stat *buf);
int lstat(const char *file_name, struct stat *buf);
int fstat(int filedes, struct stat *buf);
int iopl(int level);
int vhangup();
int swapoff(const char *path);
pid_t wait4(pid_t pid, int *status, int options, struct rusage *rusage);
int getdents(unsigned int fd, struct dirent *dirp, unsigned int count);
